#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <EzGraph.h>
#include "config.h"
#include "layout.h"
#include "obj_draw.h"
#include "draw.h"
#include "obj.h"
#include "emap.h"

#include "xpm/obj/wall.xpm"
#include "xpm/obj/sign.xpm"
#include "xpm/obj/goal_closed.xpm"
#include "xpm/obj/goal_open1.xpm"
#include "xpm/obj/goal_open2.xpm"
#include "xpm/obj/goal_opened.xpm"
#include "xpm/obj/goal_exl1.xpm"
//#include "xpm/obj/goal_exl2.xpm"
#include "xpm/obj/goal_exl3.xpm"
//#include "xpm/obj/goal_exr1.xpm"
#include "xpm/obj/goal_exr2.xpm"
//#include "xpm/obj/goal_exr3.xpm"
#include "xpm/obj/stairs_l.xpm"
#include "xpm/obj/stairs_r.xpm"
#include "xpm/obj/slope_l.xpm"
#include "xpm/obj/slope_r.xpm"
#include "xpm/obj/sting_l.xpm"
#include "xpm/obj/sting_r.xpm"
#include "xpm/obj/sting_u.xpm"
#include "xpm/obj/sting_d.xpm"
#include "xpm/obj/mswitch_on.xpm"
#include "xpm/obj/mswitch_off.xpm"
#include "xpm/obj/aswitch_on.xpm"
#include "xpm/obj/aswitch_off.xpm"

#include "xpm/obj/fwall.xpm"
#include "xpm/obj/iwall.xpm"
#include "xpm/obj/barrier0.xpm"
#include "xpm/obj/barrier1.xpm"
#include "xpm/obj/barrier2.xpm"
#include "xpm/obj/barrier3.xpm"
#include "xpm/obj/gondin.xpm"
#include "xpm/obj/gondin_sv1.xpm"
#include "xpm/obj/gondin_sv2.xpm"
#include "xpm/obj/gondin_sh1.xpm"
#include "xpm/obj/gondin_sh2.xpm"
#include "xpm/obj/gondin_bn.xpm"

#include "xpm/obj/chee16_wr0.xpm"
#include "xpm/obj/chee_init.xpm"
#include "xpm/obj/chee_back.xpm"
#include "xpm/obj/chee_exit_l1.xpm"
#include "xpm/obj/chee_exit_l2.xpm"
#include "xpm/obj/chee_exit_l3.xpm"
#include "xpm/obj/chee_exit_r1.xpm"
#include "xpm/obj/chee_exit_r2.xpm"
#include "xpm/obj/chee_exit_r3.xpm"
#include "xpm/obj/chee_e0.xpm"
#include "xpm/obj/chee_e1.xpm"
#include "xpm/obj/chee_e2.xpm"
#include "xpm/obj/chee_e7.xpm"
#include "xpm/obj/chee_e8.xpm"
#include "xpm/obj/chee_e9.xpm"
#include "xpm/obj/chee_es0.xpm"
#include "xpm/obj/chee_es1.xpm"
#include "xpm/obj/chee_es2.xpm"
#include "xpm/obj/chee_es7.xpm"
#include "xpm/obj/chee_es8.xpm"
#include "xpm/obj/chee_es9.xpm"
#include "xpm/obj/chee_wl0.xpm"
#include "xpm/obj/chee_wl1.xpm"
#include "xpm/obj/chee_wr0.xpm"
#include "xpm/obj/chee_wr1.xpm"
#include "xpm/obj/chee_jl.xpm"
#include "xpm/obj/chee_jr.xpm"
#include "xpm/obj/chee_fl.xpm"
#include "xpm/obj/chee_fr.xpm"
#include "xpm/obj/chee_svl1.xpm"
#include "xpm/obj/chee_svl2.xpm"
#include "xpm/obj/chee_svr1.xpm"
#include "xpm/obj/chee_svr2.xpm"
#include "xpm/obj/chee_shl1.xpm"
#include "xpm/obj/chee_shl2.xpm"
#include "xpm/obj/chee_shr1.xpm"
#include "xpm/obj/chee_shr2.xpm"
#include "xpm/obj/chee_gl0.xpm"
#include "xpm/obj/chee_gr0.xpm"
#include "xpm/obj/chee_bl.xpm"
#include "xpm/obj/chee_br.xpm"
#include "xpm/obj/chee_pl.xpm"
#include "xpm/obj/chee_pr.xpm"
#include "xpm/obj/chee_bnl2.xpm"
#include "xpm/obj/chee_bnr2.xpm"

#include "xpm/obj/hatopo_wl0.xpm"
#include "xpm/obj/hatopo_wl1.xpm"
#include "xpm/obj/hatopo_wr0.xpm"
#include "xpm/obj/hatopo_wr1.xpm"
#include "xpm/obj/hatopo_sl.xpm"
#include "xpm/obj/hatopo_sr.xpm"
#include "xpm/obj/hatopo_shl1.xpm"
#include "xpm/obj/hatopo_shl2.xpm"
#include "xpm/obj/hatopo_shr1.xpm"
#include "xpm/obj/hatopo_shr2.xpm"
#include "xpm/obj/hatopo_svl1.xpm"
#include "xpm/obj/hatopo_svl2.xpm"
#include "xpm/obj/hatopo_svr1.xpm"
#include "xpm/obj/hatopo_svr2.xpm"
#include "xpm/obj/hatopo_bl.xpm"
#include "xpm/obj/hatopo_br.xpm"
#include "xpm/obj/hatopo_pl.xpm"
#include "xpm/obj/hatopo_pr.xpm"
#include "xpm/obj/hatopo_bnl.xpm"
#include "xpm/obj/hatopo_bnr.xpm"



#include "xpm/obj/gagga_n0.xpm"
#include "xpm/obj/gagga_al0.xpm"
#include "xpm/obj/gagga_al1.xpm"
#include "xpm/obj/gagga_ar0.xpm"
#include "xpm/obj/gagga_ar1.xpm"
#include "xpm/obj/gagga_p.xpm"
#include "xpm/obj/gagga_bn.xpm"
#include "xpm/obj/nya_l.xpm"
#include "xpm/obj/nya_r.xpm"
#include "xpm/obj/punch_l.xpm"
#include "xpm/obj/punch_r.xpm"
#include "xpm/obj/yaarashi_wl0.xpm"
#include "xpm/obj/yaarashi_wl1.xpm"
#include "xpm/obj/yaarashi_wr0.xpm"
#include "xpm/obj/yaarashi_wr1.xpm"
#include "xpm/obj/yaarashi_pl.xpm"
#include "xpm/obj/yaarashi_pr.xpm"
#include "xpm/obj/yaarashi_bnl.xpm"
#include "xpm/obj/yaarashi_bnr.xpm"
#include "xpm/obj/ojigiri_l.xpm"
#include "xpm/obj/ojigiri_r.xpm"
#include "xpm/obj/ojigiri_el2.xpm"
#include "xpm/obj/ojigiri_el3.xpm"
#include "xpm/obj/ojigiri_el4.xpm"
#include "xpm/obj/ojigiri_er2.xpm"
#include "xpm/obj/ojigiri_er3.xpm"
#include "xpm/obj/ojigiri_er4.xpm"
#include "xpm/obj/ojigiri_d0.xpm"
#include "xpm/obj/ojigiri_d1.xpm"
#include "xpm/obj/ojigiri_svl1.xpm"
#include "xpm/obj/ojigiri_svl2.xpm"
#include "xpm/obj/ojigiri_shl1.xpm"
#include "xpm/obj/ojigiri_shl2.xpm"
#include "xpm/obj/ojigiri_svr1.xpm"
#include "xpm/obj/ojigiri_svr2.xpm"
#include "xpm/obj/ojigiri_shr1.xpm"
#include "xpm/obj/ojigiri_shr2.xpm"
#include "xpm/obj/ojigiri_bnl.xpm"
#include "xpm/obj/ojigiri_bnr.xpm"
#include "xpm/obj/sue_pl.xpm"
#include "xpm/obj/sue_pr.xpm"
#include "xpm/obj/sue_hcl2.xpm"
#include "xpm/obj/sue_hol2.xpm"
#include "xpm/obj/sue_lcl.xpm"
#include "xpm/obj/sue_lol.xpm"
#include "xpm/obj/sue_hcr2.xpm"
#include "xpm/obj/sue_hor2.xpm"
#include "xpm/obj/sue_lcr.xpm"
#include "xpm/obj/sue_lor.xpm"
//#include "xpm/obj/flame_ml.xpm"
//#include "xpm/obj/flame_mr.xpm"
#include "xpm/obj/flame_l2.xpm"
#include "xpm/obj/flame_r2.xpm"

#include "xpm/obj/bone.xpm"

#include "xpm/obj/bang4_4.xpm"
#include "xpm/obj/bang8_4.xpm"
#include "xpm/obj/bang8_8.xpm"
#include "xpm/obj/bang8_16.xpm"
#include "xpm/obj/bang12_8.xpm"

static xpm_info_t xpm_info_list[] = {
	{ii_wall, wall_xpm},
	{ii_sign, sign_xpm},
	{ii_goal_closed, goal_closed_xpm},
	{ii_goal_open1, goal_open1_xpm},
	{ii_goal_open2, goal_open2_xpm},
	{ii_goal_opened, goal_opened_xpm},
	{ii_goal_exl1, goal_exl1_xpm},
	{ii_goal_exr2, goal_exr2_xpm},
	{ii_goal_exl3, goal_exl3_xpm},
    {ii_slope_l, slope_l_xpm},
    {ii_slope_r, slope_r_xpm},
    {ii_stairs_l, stairs_l_xpm},
    {ii_stairs_r, stairs_r_xpm},
	{ii_sting_l, sting_l_xpm},
	{ii_sting_r, sting_r_xpm},
	{ii_sting_u, sting_u_xpm},
	{ii_sting_d, sting_d_xpm},
	{ii_mswitch_on, mswitch_on_xpm},
	{ii_mswitch_off, mswitch_off_xpm},
	{ii_aswitch_on, aswitch_on_xpm},
	{ii_aswitch_off, aswitch_off_xpm},

	{ii_fwall, fwall_xpm},
	{ii_iwall, iwall_xpm},
	{ii_barrier0, barrier0_xpm},
	{ii_barrier1, barrier1_xpm},
	{ii_barrier2, barrier2_xpm},
	{ii_barrier3, barrier3_xpm},
    {ii_gondin, gondin_xpm},
    {ii_gondin_sv1, gondin_sv1_xpm},
    {ii_gondin_sv2, gondin_sv2_xpm},
    {ii_gondin_sh1, gondin_sh1_xpm},
    {ii_gondin_sh2, gondin_sh2_xpm},
    {ii_gondin_bn, gondin_bn_xpm},

    {ii_chee16_wr0, chee16_wr0_xpm},
    {ii_chee_init, chee_init_xpm},
    {ii_chee_back, chee_back_xpm},
    {ii_chee_exit_l1, chee_exit_l1_xpm},
    {ii_chee_exit_l2, chee_exit_l2_xpm},
    {ii_chee_exit_l3, chee_exit_l3_xpm},
    {ii_chee_exit_r1, chee_exit_r1_xpm},
    {ii_chee_exit_r2, chee_exit_r2_xpm},
    {ii_chee_exit_r3, chee_exit_r3_xpm},
    {ii_chee_e0, chee_e0_xpm},
    {ii_chee_e1, chee_e1_xpm},
    {ii_chee_e2, chee_e2_xpm},
    {ii_chee_e7, chee_e7_xpm},
    {ii_chee_e8, chee_e8_xpm},
    {ii_chee_e9, chee_e9_xpm},
    {ii_chee_es0, chee_es0_xpm},
    {ii_chee_es1, chee_es1_xpm},
    {ii_chee_es2, chee_es2_xpm},
    {ii_chee_es7, chee_es7_xpm},
    {ii_chee_es8, chee_es8_xpm},
    {ii_chee_es9, chee_es9_xpm},
    {ii_chee_wl0, chee_wl0_xpm},
    {ii_chee_wl1, chee_wl1_xpm},
    {ii_chee_wr0, chee_wr0_xpm},
    {ii_chee_wr1, chee_wr1_xpm},
    {ii_chee_jl, chee_jl_xpm},
    {ii_chee_jr, chee_jr_xpm},
    {ii_chee_fl, chee_fl_xpm},
    {ii_chee_fr, chee_fr_xpm},
    {ii_chee_svl1, chee_svl1_xpm},
    {ii_chee_svl2, chee_svl2_xpm},
    {ii_chee_svr1, chee_svr1_xpm},
    {ii_chee_svr2, chee_svr2_xpm},
    {ii_chee_shl1, chee_shl1_xpm},
    {ii_chee_shl2, chee_shl2_xpm},
    {ii_chee_shr1, chee_shr1_xpm},
    {ii_chee_shr2, chee_shr2_xpm},
    {ii_chee_bl, chee_bl_xpm},
    {ii_chee_br, chee_br_xpm},
    {ii_chee_pl, chee_pl_xpm},
    {ii_chee_pr, chee_pr_xpm},
    {ii_chee_gl0, chee_gl0_xpm},
    {ii_chee_gr0, chee_gr0_xpm},
    {ii_chee_bnl, chee_bnl_xpm},
    {ii_chee_bnr, chee_bnr_xpm},

    {ii_hatopo_wl0, hatopo_wl0_xpm},
    {ii_hatopo_wl1, hatopo_wl1_xpm},
    {ii_hatopo_wr0, hatopo_wr0_xpm},
    {ii_hatopo_wr1, hatopo_wr1_xpm},
    {ii_hatopo_sl, hatopo_sl_xpm},
    {ii_hatopo_sr, hatopo_sr_xpm},
    {ii_hatopo_svl1, hatopo_svl1_xpm},
    {ii_hatopo_svl2, hatopo_svl2_xpm},
    {ii_hatopo_svr1, hatopo_svr1_xpm},
    {ii_hatopo_svr2, hatopo_svr2_xpm},
    {ii_hatopo_shl1, hatopo_shl1_xpm},
    {ii_hatopo_shl2, hatopo_shl2_xpm},
    {ii_hatopo_shr1, hatopo_shr1_xpm},
    {ii_hatopo_shr2, hatopo_shr2_xpm},
    {ii_hatopo_bl, hatopo_bl_xpm},
    {ii_hatopo_br, hatopo_br_xpm},
    {ii_hatopo_pl, hatopo_pl_xpm},
    {ii_hatopo_pr, hatopo_pr_xpm},
    {ii_hatopo_bnl, hatopo_bnl_xpm},
    {ii_hatopo_bnr, hatopo_bnr_xpm},

    {ii_gagga_n0, gagga_n0_xpm},
    {ii_gagga_al0, gagga_al0_xpm},
    {ii_gagga_al1, gagga_al1_xpm},
    {ii_gagga_ar0, gagga_ar0_xpm},
    {ii_gagga_ar1, gagga_ar1_xpm},
    {ii_gagga_p, gagga_p_xpm},
    {ii_gagga_bn, gagga_bn_xpm},
    {ii_nya_l, nya_l_xpm},
    {ii_nya_r, nya_r_xpm},
    {ii_punch_l, punch_l_xpm},
    {ii_punch_r, punch_r_xpm},
    {ii_sue_pl, sue_pl_xpm},
    {ii_sue_pr, sue_pr_xpm},
    {ii_sue_hcl, sue_hcl_xpm},
    {ii_sue_hol, sue_hol_xpm},
    {ii_sue_lcl, sue_lcl_xpm},
    {ii_sue_lol, sue_lol_xpm},
    {ii_sue_hcr, sue_hcr_xpm},
    {ii_sue_hor, sue_hor_xpm},
    {ii_sue_lcr, sue_lcr_xpm},
    {ii_sue_lor, sue_lor_xpm},
    {ii_flame_ml, flame_l_xpm},
    {ii_flame_mr, flame_r_xpm},
    {ii_yaarashi_wl0, yaarashi_wl0_xpm},
    {ii_yaarashi_wl1, yaarashi_wl1_xpm},
    {ii_yaarashi_wr0, yaarashi_wr0_xpm},
    {ii_yaarashi_wr1, yaarashi_wr1_xpm},
    {ii_yaarashi_pl, yaarashi_pl_xpm},
    {ii_yaarashi_pr, yaarashi_pr_xpm},
    {ii_yaarashi_bnl, yaarashi_bnl_xpm},
    {ii_yaarashi_bnr, yaarashi_bnr_xpm},
    {ii_ojigiri_l, ojigiri_l_xpm},
    {ii_ojigiri_r, ojigiri_r_xpm},
    {ii_ojigiri_el2, ojigiri_el2_xpm},
    {ii_ojigiri_el3, ojigiri_el3_xpm},
    {ii_ojigiri_el4, ojigiri_el4_xpm},
    {ii_ojigiri_er2, ojigiri_er2_xpm},
    {ii_ojigiri_er3, ojigiri_er3_xpm},
    {ii_ojigiri_er4, ojigiri_er4_xpm},
    {ii_ojigiri_d0, ojigiri_d0_xpm},
    {ii_ojigiri_d1, ojigiri_d1_xpm},

    {ii_ojigiri_svl1, ojigiri_svl1_xpm},
    {ii_ojigiri_svl2, ojigiri_svl2_xpm},
    {ii_ojigiri_shl1, ojigiri_shl1_xpm},
    {ii_ojigiri_shl2, ojigiri_shl2_xpm},
    {ii_ojigiri_svr1, ojigiri_svr1_xpm},
    {ii_ojigiri_svr2, ojigiri_svr2_xpm},
    {ii_ojigiri_shr1, ojigiri_shr1_xpm},
    {ii_ojigiri_shr2, ojigiri_shr2_xpm},
    {ii_ojigiri_bnl, ojigiri_bnl_xpm},
    {ii_ojigiri_bnr, ojigiri_bnr_xpm},

    {ii_bone, bone_xpm},

    {ii_bang4_4, bang4_4_xpm},
    {ii_bang8_4, bang8_4_xpm},
    {ii_bang8_8, bang8_8_xpm},
    {ii_bang8_16, bang8_16_xpm},
    {ii_bang12_8, bang12_8_xpm},

};
#define XPM_INFO_NUM (sizeof(xpm_info_list)/sizeof(xpm_info_t))

type2iid_info_t type2iid_info_list[] = {
    {ot_wall, ii_wall},
    {ot_sign, ii_sign},
    {ot_stairs_l, ii_stairs_l},
    {ot_stairs_r, ii_stairs_r},
    {ot_slope_l, ii_slope_l},
    {ot_slope_r, ii_slope_r},
    {ot_sting_l, ii_sting_l},
    {ot_sting_r, ii_sting_r},
    {ot_sting_u, ii_sting_u},
    {ot_sting_d, ii_sting_d},


    {ot_fwall, ii_fwall},

};
#define TYPE2IID_INFO_NUM \
    (sizeof(type2iid_info_list)/sizeof(type2iid_info_t))
image_id_t type2iid_table[ot_end];
#define Type2Iid(type) (type2iid_table[type])


motion_image_t chee_eat_motions[CHEE_EAT_COUNT][2] = {
	{{ii_chee_e0, 0, -8}, {ii_chee_es0, 0, 0}},
    {{ii_chee_e0, 0, -8}, {ii_chee_es0, 0, 0}},
    {{ii_chee_e1, 0, -8}, {ii_chee_es1, 0, 0}},
    {{ii_chee_e1, 0, -8}, {ii_chee_es1, 0, 0}},
    {{ii_chee_e2, 0, -8}, {ii_chee_es2, 0, 0}},
    {{ii_chee_e2, 0, -8}, {ii_chee_es2, 0, 0}},
    {{ii_chee_e7, 0, -8}, {ii_chee_es7, 0, 0}},
    {{ii_chee_e7, 0, -8}, {ii_chee_es7, 0, 0}},
    {{ii_chee_e8, 0, -8}, {ii_chee_es8, 0, 0}},
    {{ii_chee_e8, 0, -8}, {ii_chee_es8, 0, 0}},
    {{ii_chee_e9, 0, -8}, {ii_chee_es9, 0, 0}},
    {{ii_chee_e9, 0, -8}, {ii_chee_es9, 0, 0}},
    {{ii_chee_e9, 0, -8}, {ii_chee_es9, 0, 0}},
};

motion_image_t chee_exit_motions[CHEE_EXIT_COUNT] = {
	{ii_chee_back, 0, 0},
	{ii_chee_back, 0, 0},
	{ii_chee_back, 0, 0},
	{ii_chee_back, 0, 0},
	{ii_none, 0, 0},
	{ii_none, 0, 0},
	{ii_none, 0, 0},
	{ii_none, 0, 0},
	{ii_none, 0, 0},
	{ii_none, 0, 0},
//	{ii_chee_exit_l1, 0, 0},
//	{ii_chee_exit_l1, 0, 0},
//	{ii_chee_exit_r2, 0, 0},
//	{ii_chee_exit_r2, 0, 0},
//	{ii_chee_exit_l3, 0, 0},
//	{ii_chee_exit_l3, 0, 0},
};

motion_image_t goal_exit_motions[CHEE_EXIT_COUNT] = {
	{ii_goal_opened, 0, 0},
	{ii_goal_opened, 0, 0},
	{ii_goal_opened, 0, 0},
	{ii_goal_opened, 0, 0},
	{ii_goal_exl1, 0, 0},
	{ii_goal_exl1, 0, 0},
	{ii_goal_exr2, 0, 0},
	{ii_goal_exr2, 0, 0},
	{ii_goal_exl3, 0, 0},
	{ii_goal_exl3, 0, 0},
};


motion_image_t ojigiri_eat_motions[OJIGIRI_EAT_COUNT][2] = {
	{{ii_ojigiri_l,    0, 0}, {ii_ojigiri_r,   0, 0}},
	{{ii_ojigiri_el2, -8, 8}, {ii_ojigiri_er2, 0, 8}},
	{{ii_ojigiri_el2, -8, 8}, {ii_ojigiri_er2, 0, 8}},
	{{ii_ojigiri_el2, -8, 8}, {ii_ojigiri_er2, 0, 8}},
	{{ii_ojigiri_el3, -8, 8}, {ii_ojigiri_er3, 0, 8}},
	{{ii_ojigiri_el3, -8, 8}, {ii_ojigiri_er3, 0, 8}},
	{{ii_ojigiri_el3, -8, 8}, {ii_ojigiri_er3, 0, 8}},
	{{ii_ojigiri_el4,  0, 0}, {ii_ojigiri_er4, 0, }},
	{{ii_ojigiri_el4,  0, 0}, {ii_ojigiri_er4, 0, 0}},
	{{ii_ojigiri_el4,  0, 0}, {ii_ojigiri_er4,  0, 0}},
};

motion_image_t ojigiri_vomit_motions[OJIGIRI_VOMIT_COUNT][2] = {
	{{ii_ojigiri_l,    0, 0}, {ii_ojigiri_r,   0, 0}},
	{{ii_ojigiri_el3, -8, 8}, {ii_ojigiri_er2, 0, 8}},
	{{ii_ojigiri_el2, -8, 8}, {ii_ojigiri_er2, 0, 8}},
	{{ii_ojigiri_el2, -8, 8}, {ii_ojigiri_er2, 0, 8}},
	{{ii_ojigiri_el2, -8, 8}, {ii_ojigiri_er3, 0, 8}},
	{{ii_ojigiri_el2, -8, 8}, {ii_ojigiri_er3, 0, 8}},
	{{ii_ojigiri_el2, -8, 8}, {ii_ojigiri_er3, 0, 8}},
	{{ii_ojigiri_el3, -8, 8}, {ii_ojigiri_er3, 0, 8}},
	{{ii_ojigiri_l,    0, 0}, {ii_ojigiri_r,   0, 0}},
	{{ii_ojigiri_l,    0, 0}, {ii_ojigiri_r,   0, 0}},
	{{ii_ojigiri_l,    0, 0}, {ii_ojigiri_r,   0, 0}},
	{{ii_ojigiri_l,    0, 0}, {ii_ojigiri_r,   0, 0}},
};

motion_image_t gagga_hit_motions[GAGGA_HIT_COUNT][2] = {
	{{ii_gagga_al0, 0, 0}, {ii_gagga_ar0, 0, 0}},
	{{ii_gagga_al0, 0, 0}, {ii_gagga_ar0, 0, 0}},
//	{{ii_gagga_al0, 0, 0}, {ii_gagga_ar0, 0, 0}},
//	{{ii_gagga_al0, 0, 0}, {ii_gagga_ar0, 0, 0}},
	{{ii_gagga_al1, -4, 0}, {ii_gagga_ar1, 0, 0}},
	{{ii_gagga_al1, -4, 0}, {ii_gagga_ar1, 0, 0}},
	{{ii_gagga_al1, -4, 0}, {ii_gagga_ar1, 0, 0}},
	{{ii_gagga_al1, -4, 0}, {ii_gagga_ar1, 0, 0}},
	{{ii_gagga_al1, -4, 0}, {ii_gagga_ar1, 0, 0}},
	{{ii_gagga_al1, -4, 0}, {ii_gagga_ar1, 0, 0}},
};


static EzImage imgs[ii_end];

void obj_draw_init(void){
    int i;
    for (i = 0 ; i < XPM_INFO_NUM ; i++){
        imgs[xpm_info_list[i].iid] = EzReadXPM(xpm_info_list[i].xpm);
    }
    for (i = 0 ; i < TYPE2IID_INFO_NUM ; i++){
        type2iid_table[type2iid_info_list[i].type] 
            = type2iid_info_list[i].iid;
    }
}

void draw_img(image_id_t iid, int x, int y){
    DrawImg(x, y, imgs[iid]);
}

int draw_motion(obj_t *obj){
    if (obj->motion != ii_none){
        draw_img(obj->motion, obj->x, obj->y);
    }
    return 0;
}

/*
int draw_creature(obj_t *obj){
	switch (State(obj)){
	case os_pierced:
	case os_bang:
		draw_img(creature_image_table[obj->type].bang;
		break;
	}
}
*/

int draw_fwall(obj_t *obj){
    if (IsAlive(obj)){
	    draw_img(ii_fwall, obj->x, obj->y);
    }
    else {
        draw_img(ii_fwall, obj->x, obj->y);
    }
    return 0;
}
int draw_iwall(obj_t *obj){
    if (IsAlive(obj)){
	    draw_img(ii_iwall, obj->x, obj->y);
    }
    else {
	    draw_img(ii_iwall, obj->x, obj->y);
    }
    return 0;
}

int draw_chee(obj_t *obj){
	motion_image_t mi;

	if (State(obj) == os_exit){
		mi = chee_exit_motions[Ctr(obj)];
        if (mi.iid != ii_none){
            draw_img(mi.iid, obj->x+mi.xoffset, obj->y+mi.yoffset);
        }
	}
	else if (IsEating(obj)){
        if (check_emap_box_any(Ltx(obj), Lty(obj)-7, obj->width, obj->height,
                               eb_block_up))
        {
            puts("blocking eat");
            mi = chee_eat_motions[Ctr(obj)][1];
        }
        else {
            puts("nonblocking eat");
            mi = chee_eat_motions[Ctr(obj)][0];
        }
		draw_img(mi.iid, obj->x+mi.xoffset, obj->y+mi.yoffset);
    }
    else {
        draw_motion(obj);
    }
    return 0;
}

int post_draw_ojigiri(obj_t *obj){
	int dirix, bx, by, offset = 0;
	motion_image_t mi;
    switch (State(obj)){
    case os_eating:
		dirix = (obj->dir == di_left) ? 0 : 1;
		mi = ojigiri_eat_motions[Ctr(obj)][dirix];
        draw_img(mi.iid, obj->x+mi.xoffset, obj->y+mi.yoffset);
        break;
    case os_vomitting:
        if (Ctr(obj) > 1){
            if (Ctr(obj) < 5){
                offset = 5 - Ctr(obj);
            }
            bx = (obj->dir == di_left) ?
                Ltx(obj)-8+offset : Rtx(obj)+4-offset;
            by = Rby(obj) - 3 - offset;
            draw_img(ii_bone, bx, by);
        }
		dirix = (obj->dir == di_left) ? 0 : 1;
		mi = ojigiri_vomit_motions[Ctr(obj)][dirix];
        draw_img(mi.iid, obj->x+mi.xoffset, obj->y+mi.yoffset);
        break;
    default:
        draw_img(obj->motion, obj->x, obj->y);
        break;
    }
    return 0;
}

int draw_goal(obj_t *obj){
	motion_image_t mi;
    switch (State(obj)){
	case os_exit:
		mi = goal_exit_motions[Ctr(obj)];
		draw_img(mi.iid, obj->x+mi.xoffset, obj->y+mi.yoffset);
		break;
	default:
        draw_motion(obj);
		break;
	}
	return 0;
}

int draw_gagga(obj_t *obj){
	dir_t dirix;
	motion_image_t mi;

	switch(State(obj)){
	case os_blast:
		dirix = (obj->dir == di_left) ? 0 : 1;
		mi = gagga_hit_motions[Ctr(obj)][dirix];
        draw_img(mi.iid, obj->x+mi.xoffset, obj->y+mi.yoffset);
		break;
	default:
	    draw_motion(obj);
		break;
	}
    return 0;
}

int post_draw_gagga(obj_t *obj){
	if (State(obj) == os_blast && Ctr(obj) > GAGGA_BLAST_COUNT){
		if (obj->dir == di_left){
	        draw_img(ii_bang8_8, Ltx(obj)-3-8, Lty(obj));
		}
		else {
	        draw_img(ii_bang8_8, Rtx(obj)+4, Lty(obj));
		}
	}
	return 0;
}

int draw_nya(obj_t *obj){
    int lx, rx;
	// ˤ㤢ȥѥνŤ͹礻ꤹ뤿ᡢǥѥޤȤ
	SetColor(7);
    if (obj->dir == di_left){
        lx = obj->link->x+obj->link->width/2;
        rx = obj->x+obj->width/2;
    }
    else {
        lx = obj->x+obj->width/2;
        rx = obj->link->x+obj->link->width/2;
    }
    EzFillBoxB(lx*4, (obj->y+8+1)*4+2, rx*4, (obj->y+8+1)*4+2+3);
    draw_img(obj->link->motion, obj->link->x, obj->link->y);
    draw_img(obj->motion, obj->x, obj->y);
    return 0;
}

int draw_punch(obj_t *obj){
	// ˤ㤢ΤȤ褹Τǡ϶ˤƤ
    return 0;
}

int draw_static(obj_t *obj){
    draw_img(Type2Iid(obj->type), obj->x, obj->y);
    return 0;
}

void draw_wall(obj_t *obj){
    //    DrawImg(obj->x, obj->y, img_wall);
    /*
    int x, y, w, h;
    x = obj->x;
    y = obj->y;
    w = obj->width;
    h = obj->height;
        printf("draw wall(%d, %d)\n", x, y);
    SetColor(2);
    DrawFillBox(x, y, w, h);
    SetColor(0);
    EzDrawLineB(DLTX(x), DLTY(y), DRBX(x+w-1), DLTY(y));
    EzDrawLineB(DLTX(x), DLTY(y+h/2), DRBX(x+w-1), DLTY(y+h/2));
    EzDrawLineB(DLTX(x+w/4), DLTY(y), DLTX(x+w/4), DLTY(y+h/2));
    EzDrawLineB(DLTX(x+w*3/4), DLTY(y+h/2), DLTX(x+w*3/4), DRBY(y+h-1));
    */
}
int draw_lift(obj_t *obj){
    int x, y, w, h;
    x = obj->x;
    y = obj->y;
    w = obj->width;
    h = obj->height;
    SetColor(4);
    DrawFillBox(x, y, w, h);
    return 0;
}

int draw_switch(obj_t *obj){
	int x;
	for (x = Ltx(obj) ; x < Rtx(obj) ; x+=GRID_SIZE){
	    draw_img(obj->motion, x, obj->y);
	}
	return 0;
}

int draw_barrier(obj_t *obj){
	int x, y;
    //    printf("draw barrier(%d, %d) %d (%d, %d)(%d, %d)\n", obj->width, obj->height, obj->motion, Ltx(obj), Rbx(obj), Lty(obj), Rby(obj));
    if (State(obj) == os_on){
        for (y = Lty(obj) ; y < Rby(obj) ; y+=GRID_SIZE){
            for (x = Ltx(obj) ; x < Rbx(obj) ; x+=GRID_SIZE){
                //                printf("draw img:(%d,%d)%d\n", x, y, obj->motion);
                draw_img(obj->motion, x, y);
            }
        }
	}
	return 0;
}


void draw_hitmarker(void){
    int x, y;
    int r, g, b;
    puts("draw hitmarker");
    for (y = 0 ; y < MAP_HEIGHT ; y++){
        for (x = 0 ; x < MAP_WIDTH ; x++){
            if (emap[current_emap][y][x] == 0) continue;
            r = g = b = 128;
            if (CheckEMap(x, y, eb_block_up)){
                b = 0;
            }
            if (CheckEMap(x, y, eb_block_down)){
                b = 255;
            }
            if (CheckEMap(x, y, eb_block_left)){
                g = 0;
            }
            if (CheckEMap(x, y, eb_block_right)){
                g = 255;
            }
            if (CheckEMap(x, y, eb_push_left)){
               g -= 100;
            }
            if (CheckEMap(x, y, eb_push_right)){
               g += 100;
            }
            if (CheckEMap(x, y, eb_push_up)){
               b -= 100;
            }
            if (CheckEMap(x, y, eb_push_down)){
               b += 100;
            }
            if (CheckEMap(x, y, eb_push_leftdown)){
                r = 255;
            }
            if (CheckEMap(x, y, eb_push_rightdown)){
                b = 255;
            }
            if (GetEMapOwner(x, y, eb_meat)){ g = 256; r = 0 ; b = 0;}
            printf("[%d, %d, %d]\n", r, g, b);
            EzSetColorByRGB(r, g, b);
            EzFillBoxB(DLTX(x), DLTY(y), DRBX(x), DRBY(y));
        }
    }
}

